/******************************************************************************
 * 
 * Copyright 2012 - 2014 Vektor Software.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 *****************************************************************************/


package com.vektorsoft.demux.core.app;

import com.vektorsoft.demux.core.mva.DMXAdapter;

/**
 * This class is intended to be used in conjunction with {@link DMXAdapterTrackerCustomizer}. It is used as 
 * a callback object to customize method for tracking services.
 *
 * @author Vladimir Djurovic
 */
public abstract class DMXAdapterTrackerHandler {
    
    /**
     * Invoked when adapter service is added.
     * 
     * @param adapter adapter service
     */
    public abstract void onAdapterAdded(DMXAdapter adapter);
    
    /**
     * Invoked when adapter is modified.
     * 
     * @param adapter  adapter service
     */
    public abstract void onAdapterModified(DMXAdapter adapter);
    
    /**
     * Invoked when adapter is removed.
     * 
     * @param adapter adapter service
     */
    public abstract void onAdapterRemoved(DMXAdapter adapter);
}
