/******************************************************************************
 * 
 * Copyright 2012 - 2013 Vektor Software.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 *****************************************************************************/

package com.vektorsoft.demux.core.app;

import java.util.Map;

/**
 * <p>
 *  Listener for changes in model data. This listener is notified when some of the data in
 * model changes, as a result of controller execution.
 * </p>
 *
 * @author Vladimir Djurovic
 */
public interface ModelChangeListener {

    /**
     * Notifies listener that model data has changed.
     * 
     * @param modelData changed data
     */
    void modelChanged(Map<String, Object> modelData);
}
