/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */


package com.vektorsoft.demux.samples.hello.android.annotated;

import android.content.Context;
import android.graphics.Color;
import android.view.View;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.TextView;
import com.vektorsoft.demux.android.core.app.DMXAndroidViewManager;
import com.vektorsoft.demux.core.annotations.DMXModelData;
import com.vektorsoft.demux.core.annotations.DMXViewDeclaration;
import com.vektorsoft.demux.core.mva.DMXAdapter;

/**
 *
 * @author Vladimir Djurovic
 */
@DMXViewDeclaration (viewID = "annotatedView", parentViewId = DMXAndroidViewManager.DMX_ANDROID_ROOT_VIEW)
public class AndroidAnnotatedView {
    
    @DMXViewDeclaration.ViewUI
    private LinearLayout root;
    private TextView text;
    private DMXAdapter adapter;
    
    private Context context;
    
    @DMXModelData
    private boolean testData;
    
    public AndroidAnnotatedView(Context ctx, DMXAdapter adapter) {
        this.context = ctx;
        this.adapter = adapter;
    }

    @DMXViewDeclaration.Render
    public void renderView() {
        if (testData) {
            text.setTextColor(Color.GREEN);
        } else {
            text.setTextColor(Color.RED);
        }
    }
    
    @DMXViewDeclaration.ConstructUI
    public void makeUI(){
	root = new LinearLayout(context);
        text = new TextView(context);
        text.setText("Hello, DEMUX!");
        root.addView(text);

        Button button = new Button(context);
        button.setText("Click me");
        button.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                adapter.invokeController("com.vektorsoft.demux.samples.annotated.HelloController");
            }
        });
        root.addView(button);
    }
    
    public LinearLayout getRoot(){
      return root;
    }
    
    public void setTestData(boolean test){
      this.testData = test;
    }
    
    public boolean getTestData(){
      return testData;
    }
}
