/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */


package com.vektorsoft.demux.samples.dlg.jfx;

import com.vektorsoft.demux.core.annotations.DMXModelData;
import com.vektorsoft.demux.core.annotations.DMXViewDeclaration;
import com.vektorsoft.demux.core.dlg.DMXDialog;
import com.vektorsoft.demux.core.mva.DMXAdapter;
import com.vektorsoft.demux.desktop.jfx.view.JFXRootView;
import com.vektorsoft.demux.desktop.jfx.view.dlg.JFXDialogFactory;
import com.vektorsoft.demux.desktop.jfx.view.dlg.JFXDialogStage;
import com.vektorsoft.demux.desktop.jfx.view.dlg.JFXOptionStage;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.scene.control.Button;
import javafx.scene.layout.HBox;
import javafx.scene.text.Text;

/**
 *
 * @author Vladimir Djurovic
 */
@DMXViewDeclaration (viewID = "mainView", parentViewId = JFXRootView.JFX_ROOT_VIEW_ID)
public class MainView {
    
    private DMXAdapter adapter;

    @DMXViewDeclaration.ViewUI
    private HBox hbox;
    private Text text;
    private Button button;
    private Button optionButton;
    private Button customButton;
    private Button taskbutton;
    
    @DMXModelData
    private String username;
    
    public MainView(DMXAdapter adapter){
       this.adapter = adapter;
    }
    
    @DMXViewDeclaration.Render
    public void render(){
        text.setText("Username: " + username);
    }
    
    @DMXViewDeclaration.ConstructUI
    public void makeUI(){
       hbox = new HBox(10.0);
        
        text = new Text("Username:");
        hbox.getChildren().add(text);
        
        button = new Button("Change name");
        button.setOnAction(new EventHandler<ActionEvent>() {

            @Override
            public void handle(ActionEvent t) {
                JFXDialogFactory factory = adapter.getDialogFactory(JFXDialogFactory.class);
                JFXDialogStage dlg = factory.createDialog("simpleDialog", "Custom name");
                dlg.showDialog();
                adapter.invokeController("namectrl", dlg.getDialogView().getResult().toString());
            }
        });
        hbox.getChildren().add(button);
        
        optionButton = new Button("Show options");
        optionButton.setOnAction(new EventHandler<ActionEvent>() {

            @Override
            public void handle(ActionEvent t) {
                JFXDialogFactory factory =  adapter.getDialogFactory(JFXDialogFactory.class);
                JFXOptionStage dlg = factory.createOptionDialog(null, "Options dialog", 
                                                      DMXDialog.OPTIONS_YES_NO_CANCEL,
                                                      "This is options dialog");
                int result = dlg.showDialog();
                System.out.println("Option: " + result);
            }
        });
        hbox.getChildren().add(optionButton);
        
        customButton = new Button("Custom options");
        customButton.setOnAction(new EventHandler<ActionEvent>() {

            @Override
            public void handle(ActionEvent t) {
                JFXDialogFactory factory = adapter.getDialogFactory(JFXDialogFactory.class);
                JFXOptionStage dlg = factory.createOptionDialog(null, "Custom options dialog", new String[]{"Option 1","Option 2", "Option 3"}, "Custom options dialog");
                int result = dlg.showDialog();
                System.out.println("Option: " + result);
            }
        });
        hbox.getChildren().add(customButton);
        
        taskbutton = new Button("Task");
        taskbutton.setOnAction(new EventHandler<ActionEvent>() {

            @Override
            public void handle(ActionEvent t) {
                
            }
        });
        hbox.getChildren().add(taskbutton);
    }
    
    public HBox getHbox(){
      return hbox;
    }
    
     public void setUsername(String username){
      this.username = username;
    }
    
    public String getUsername(){
      return username;
    }
}
