/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */


package com.vektorsoft.demux.samples.dlg.jfx;

import com.vektorsoft.demux.core.annotations.DMXDialogResult;
import com.vektorsoft.demux.core.annotations.DMXModelData;
import com.vektorsoft.demux.core.annotations.DMXViewDeclaration;
import com.vektorsoft.demux.core.dlg.DMXDialog;
import com.vektorsoft.demux.core.mva.DMXAdapter;
import com.vektorsoft.demux.desktop.jfx.view.dlg.JFXDialogFactory;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.scene.control.Button;
import javafx.scene.control.TextField;
import javafx.scene.layout.HBox;
import javafx.scene.text.Text;

/**
 *
 * @author Vladimir Djurovic
 */
@DMXViewDeclaration (viewID = "simpleDialog", parentViewId = "", isDialog = true, title = "My Dialog")
public class SimpleDialogView {
    
    @DMXViewDeclaration.ViewUI
    private HBox hbox;
    private TextField field;
    private Button button;
    
 
    private DMXDialog dialog;
    private DMXAdapter adapter;
    
    @DMXModelData
    private String username;
    
    public SimpleDialogView(DMXAdapter adapter){
       this.adapter = adapter;
    }

    @DMXDialogResult
    public Object getResult() {
        return field.getText();
    }

    @DMXViewDeclaration.Render
    public void render() {
        field.setText(username);
    }
    
    @DMXViewDeclaration.ConstructUI
    public void makeUI(){
      
       hbox = new HBox(10.0);
        
        hbox.getChildren().add(new Text("Enter your name: "));
        
        field = new TextField();
        hbox.getChildren().add(field);
        
        button = new Button("Submit");
        button.setOnAction(new EventHandler<ActionEvent>() {

            @Override
            public void handle(ActionEvent t) {
                if(field.getText() == null || field.getText().isEmpty()){
                    JFXDialogFactory factory = adapter.getDialogFactory(JFXDialogFactory.class);
                    factory.createOptionDialog(null, "Error", DMXDialog.OPTIONS_OK, "You must enter a name.").showDialog();
                    return;
                }
                dialog.closeDialog();
            }
        });
        hbox.getChildren().add(button);
    }
    
    public HBox getHbox(){
      return hbox;
    }

     public void setUsername(String username){
      this.username = username;
    }
    
    public String getUsername(){
      return username;
    }
    
     public void setDialog(DMXDialog dlg){
      this.dialog = dlg;
    }
    
    public DMXDialog getDialog(){
      return dialog;
    }

}
