/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */


package com.vektorsoft.demux.samples.i18n.jfx;

import com.vektorsoft.demux.core.annotations.DMXViewDeclaration;
import com.vektorsoft.demux.core.mva.DMXAdapter;
import com.vektorsoft.demux.core.resources.LocaleChangeListener;
import com.vektorsoft.demux.desktop.jfx.gui.DMXLoaderFXML;
import java.io.IOException;
import javafx.scene.layout.BorderPane;

/**
 * Locale aware view which uses FXML to construct UI.
 *
 * @author Vladimir Djurovic
 */
@DMXViewDeclaration (parentViewId = "com.vektorsoft.demux.samples.i18n.jfx.LocaleView", viewID = "fxmlLocaleView")
public class FXMLocaleView implements LocaleChangeListener{

    @DMXViewDeclaration.ViewUI
    private BorderPane root;
    
    private DMXAdapter adapter;
    
    private DMXLoaderFXML loader;
    
    public FXMLocaleView(DMXAdapter adapter){
        this.adapter = adapter;
    }
    
    @DMXViewDeclaration.ConstructUI
    public void createUI(){
        try{
            loader = new DMXLoaderFXML(this.getClass().getClassLoader().getResource("/fxmllocaleview.xml"), adapter.getResourceManager());
            root = (BorderPane)loader.load();
        } catch(IOException ex){
            ex.printStackTrace(System.err);
        }
    }
    
    @DMXViewDeclaration.Render
    public void render(){
        
    }

    public BorderPane getRoot() {
        return root;
    }

    @Override
    public void onLocaleChange() {
        System.out.println("Locale changed");
        loader.updateNodeHierarchy(root);
    }
    
}
